package com.njcn.utils;

import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.List;

import com.njcn.serviceimpl.weeklyreport.WeeklyReportDataServiceImpl;
import org.apache.poi.hssf.usermodel.HSSFCell;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.web.multipart.MultipartFile;

import com.njcn.pojo.commons.DevList;

public class ImportExl {
    private static final Logger logger = LoggerFactory.getLogger(ImportExl.class);
    //总行数
    private int totalRows = 0;
    //总条数
    private int totalCells = 0;
    //错误信息接收器
    private String errorMsg;

    //构造方法
    public ImportExl() {
    }

    //获取总行数
    public int getTotalRows() {
        return totalRows;
    }

    //获取总列数
    public int getTotalCells() {
        return totalCells;
    }

    //获取错误信息
    public String getErrorInfo() {
        return errorMsg;
    }

    /**
     * 读EXCEL文件，获取信息集合
     *
     * @param
     * @param
     * @return
     */
    public List<DevList> getExcelInfo(MultipartFile mFile) {
        String fileName = mFile.getOriginalFilename();//获取文件名
        List<DevList> userList = null;
        try {
            if (!validateExcel(fileName)) {// 验证文件名是否合格
                return null;
            }
            boolean isExcel2003 = true;// 根据文件名判断文件是2003版本还是2007版本
            if (isExcel2007(fileName)) {
                isExcel2003 = false;
            }
            userList = createExcel(mFile.getInputStream(), isExcel2003);
        } catch (Exception e) {

        }
        return userList;
    }

    /**
     * 根据excel里面的内容读取终端信息
     *
     * @param is          输入流
     * @param isExcel2003 excel是2003还是2007版本
     * @return
     * @throws IOException
     */
    public List<DevList> createExcel(InputStream is, boolean isExcel2003) {
        List<DevList> userList = null;
        try {
            Workbook wb = null;
            if (!isExcel2003) {// 当excel是2003时,创建excel2003
                wb = new XSSFWorkbook(is);
            } else {// 当excel是2007时,创建excel2007
                wb = new HSSFWorkbook(is);
            }
            userList = readExcelValue(wb);// 读取Excel里面客户的信息
            wb = null;
        } catch (IOException e) {
            logger.error(e.getMessage());
        }
        return userList;
    }

    /**
     * 读取Excel里面终端的信息
     *
     * @param wb
     * @return
     */
    private List<DevList> readExcelValue(Workbook wb) {
        // 得到第一个shell
        Sheet sheet = wb.getSheetAt(0);
        // 得到Excel的行数
        this.totalRows = this.readExcelValueRows(sheet);
        // 得到Excel的列数(前提是有行数)
        if (totalRows > 1 && sheet.getRow(1) != null) {
            this.totalCells = sheet.getRow(1).getPhysicalNumberOfCells();
        }
        List<DevList> userList = new ArrayList<DevList>();
        // 循环Excel行数
        for (int r = 2; r <= totalRows; r++) {
            Row row = sheet.getRow(r);
            if (row == null) {
                continue;
            }
            DevList user = new DevList();
            // 循环Excel的列
            for (int c = 0; c < this.totalCells; c++) {
                Cell cell = row.getCell(c);
                if (null != cell) {
                	if (c == 0) {
                         user.setProjectName(cell.getStringCellValue());//项目名称
                    } else if (c == 1) {
                        if (cell.getStringCellValue() == "" || cell.getStringCellValue() == null) {
                            break;
                        }
                        user.setProName(cell.getStringCellValue());//省份
                    } else if (c == 2) {
                        user.setGdName(cell.getStringCellValue());//供电公司
                    } else if (c == 3) {
                        user.setDept(cell.getStringCellValue());//所属部门
                    } else if (c == 4) {
                        user.setSubName(cell.getStringCellValue());//变电站
                    } else if (c == 5) {
                    	user.setSubScale(cell.getStringCellValue());//变电站电压等级
                    } else if (c == 6) {
                        if (cell.getCellType() == HSSFCell.CELL_TYPE_NUMERIC) {
                            Float longItude = Float.valueOf((float) cell.getNumericCellValue());
                            user.setLongItude(longItude);//经度

                        } else {
                            //判断失败
                        }
                    } else if (c == 7) {
                        if (cell.getCellType() == HSSFCell.CELL_TYPE_NUMERIC) {
                            Float latItude = Float.valueOf((float) cell.getNumericCellValue());//纬度
                            user.setLatItude(latItude);//纬度
                        } else {
                            //判断失败
                        }
                    } else if (c == 8) {
                        if (cell.getCellType() == HSSFCell.CELL_TYPE_NUMERIC) {
                            user.setDevName(String.valueOf((long) cell.getNumericCellValue()));//终端名称
                        } else {    
                            user.setDevName(cell.getStringCellValue());
                        }
                    } else if (c == 9) {
                        user.setIp(cell.getStringCellValue());//IP
                    } else if (c == 10) {
                        user.setManufacturer(cell.getStringCellValue());//厂家
                    } else if (c == 11) {
                        user.setDevmodel(cell.getStringCellValue());//终端模型
                    } else if (c == 12) {
                        user.setDevtype(cell.getStringCellValue());//终端型号
                    } else if (c == 13) {
                        user.setNodename(cell.getStringCellValue());//所属前置机
                    } else if (c == 14) {
                        user.setPortid((int) cell.getNumericCellValue());//SIM卡号
                    }  else if (c == 15) {
                        user.setSim( cell.getStringCellValue());//监测装置安装位置
                    } else if (c == 16) {
                        user.setDevLocation( cell.getStringCellValue());//监测厂家设备编号
                    }else if (c == 17) {
                        user.setDevNo( cell.getStringCellValue());//监测厂家设备编号
                    } else if (c == 18) {
                        if (cell.getCellType() == HSSFCell.CELL_TYPE_NUMERIC) {
                            user.setSeries(String.valueOf((long)cell.getNumericCellValue()));//识别码
                        } else {
                            user.setSeries(cell.getStringCellValue());//识别码
                        }

                    } else if (c == 19) {
                        if (cell.getCellType() == HSSFCell.CELL_TYPE_NUMERIC) {
                            user.setKey(String.valueOf((long)cell.getNumericCellValue()));//秘钥
                        } else {
                            user.setKey(cell.getStringCellValue());//秘钥
                        }

                    } else if (c == 20) {
                    	if (cell.getCellType() == HSSFCell.CELL_TYPE_NUMERIC) {
                            user.setSubvName(String.valueOf((long) cell.getNumericCellValue()));//母线名称
                        } else {
                            user.setSubvName(cell.getStringCellValue());
                        }
                    } else if (c == 21) {
                        user.setSubvnum((int) cell.getNumericCellValue());//母线号
                    } else if (c == 22) {
                    	user.setScale(cell.getStringCellValue());
                    } else if (c == 23) {
                    	if (cell.getCellType() == HSSFCell.CELL_TYPE_NUMERIC) {
                            user.setLineName(String.valueOf((long) cell.getNumericCellValue()));//监测点名称
                        } else {
                            user.setLineName(cell.getStringCellValue());
                        }
                    } else if (c == 24) {
                        user.setLineNum((int) cell.getNumericCellValue());//监测点号
                    } else if (c == 25) {
                        user.setPt(cell.getStringCellValue());//pt
                    } else if (c == 26) {
                        user.setCt(cell.getStringCellValue());//ct
                    } else if (c == 27) {
                        if (cell.getCellType() == HSSFCell.CELL_TYPE_NUMERIC) {
                            Float dlrl = Float.valueOf((float) cell.getNumericCellValue());
                            user.setDlrl(dlrl);//短路容量

                        } else {
                            //判断失败
                        }
                    } else if (c == 28) {
                        if (cell.getCellType() == HSSFCell.CELL_TYPE_NUMERIC) {
                            Float sbrl = Float.valueOf((float) cell.getNumericCellValue());
                            user.setSbrl(sbrl);//设备容量

                        } else {
                            //判断失败
                        }
                    } else if (c == 29) {
                        if (cell.getCellType() == HSSFCell.CELL_TYPE_NUMERIC) {
                            Float xyrl = Float.valueOf((float) cell.getNumericCellValue());
                            user.setXyrl(xyrl);//协议容量

                        } else {
                            //判断失败
                        }
                    } else if (c == 30) {
                        user.setPttype(cell.getStringCellValue());//接线方式
                    } else if (c == 31) {
                    	user.setInterval((int) cell.getNumericCellValue());//间隔时间
                    } else if (c == 32) {
                        user.setLoadType(cell.getStringCellValue());//干扰源类型
                    } else if (c == 33) {
                        user.setBusinessType(cell.getStringCellValue());//行业类型
                    } else if (c == 34) {
                        user.setPowerId(cell.getStringCellValue());//监测点性质
                    } else if (c == 35) {
                        user.setPowerSubstationName(cell.getStringCellValue());//电网侧变电站
                    } else if (c == 36) {
                        user.setIsGridPoint(cell.getStringCellValue());//是否并网点
                    } else if (c == 37) {
                        user.setStatus(cell.getStringCellValue());//监测点运行状态
                    } else if (c == 38) {
                        user.setMonitorid(cell.getStringCellValue());//国网ID
                    } else if (c == 39) {
                        user.setObjName(cell.getStringCellValue()); //监测点对象名称
                    }else if (c == 40) {
                        user.setStatFlag(cell.getStringCellValue()); //统计类型
                    }else if (c == 41) {  //add by sw
                        user.setFileName(cell.getStringCellValue()); //文件名
                    }
                }
            }
            // 添加到list
            userList.add(user);
            //iim.exportGirdTop(userList);
        }
        return userList;
    }

    /**
     * 验证EXCEL文件
     *
     * @param filePath
     * @return
     */
    public boolean validateExcel(String filePath) {
        if (filePath == null) {
            errorMsg = "文件名不是excel格式";
            return false;
        }
        return true;
    }

    // @描述：是否是2003的excel，返回true是2003
    public static boolean isExcel2003(String filePath) {
        return filePath.matches("^.+\\.(?i)(xls)$");
    }

    //@描述：是否是2007的excel，返回true是2007
    public static boolean isExcel2007(String filePath) {
        return filePath.matches("^.+\\.(?i)(xlsx)$");
    }


    /**
     * 获取excel真实行数
     * @author cdf
     * @date 2021/7/8
     */
    public int readExcelValueRows(Sheet sheet) {
        int realRow = 0;// 返回的真实行数
        for (int i = 1; i <= sheet.getLastRowNum(); i++) {
            //i从1开始，不判断第一行标题行
            Row row = sheet.getRow(i);
            if (row == null){
                continue;
            }
            Cell cell = row.getCell(0);
                if (cell == null){
                    continue;
                }
                String value = cell.getStringCellValue();
                if (value == null || "".equals(value)){
                    continue;
                } else{
                    realRow++;
                }

        }
        return realRow;
    }




}
